diff --git a/Makefile.am b/Makefile.am
index 430fd9fd8..610eb9f79 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -94,10 +94,6 @@ EXTRA_DIST = \
 	.travis/osx-build.sh \
 	.travis/osx-prepare.sh \
 	boot.sh \
-	poc/builders/Vagrantfile \
-	poc/playbook-centos-builder.yml \
-	poc/playbook-fedora-builder.yml \
-	poc/playbook-ubuntu-builder.yml \
 	$(MAN_FRAGMENTS) \
 	$(MAN_ROOTS) \
 	Vagrantfile \
diff --git a/poc/builders/Vagrantfile b/poc/builders/Vagrantfile
deleted file mode 100644
index 9edc468a3..000000000
--- a/poc/builders/Vagrantfile
+++ /dev/null
@@ -1,45 +0,0 @@
-# -*- mode: ruby -*-
-# vi: set ft=ruby :
-
-VAGRANTFILE_API_VERSION = "2"
-
-Vagrant.configure(VAGRANTFILE_API_VERSION) do |config|
-  config.ssh.insert_key = false
-
-  # Centos-7.4 builder host
-  config.vm.define "centosbuilder" do |builder|
-    builder.vm.hostname = "centosbuilder.dev"
-    builder.vm.box = "centos/7"
-    builder.vm.synced_folder "../../", "/git/ovs", type: "rsync",
-                             rsync__args: ["--archive", "--delete", "-z"]
-    builder.vm.provision "builder", type: "ansible" do |ansible|
-      ansible.playbook = "../playbook-centos-builder.yml"
-      ansible.sudo = true
-    end
-  end
-
-  # Ubuntu-16.04 builder host
-  config.vm.define "ubuntubuilder" do |builder|
-    builder.vm.hostname = "ubuntubuilder.dev"
-    builder.vm.box = "generic/ubuntu1604"
-    builder.vm.synced_folder "../../", "/git/ovs", type: "rsync",
-                             rsync__args: ["--archive", "--delete", "-z"]
-    builder.vm.provision "builder", type: "ansible" do |ansible|
-      ansible.playbook = "../playbook-ubuntu-builder.yml"
-      ansible.sudo = true
-    end
-  end
-
-  # Fedora builder host
-  config.vm.define "fedorabuilder" do |builder|
-    builder.vm.hostname = "fedoraubuilder.dev"
-    builder.vm.box = "fedora/27-cloud-base"
-    builder.vm.synced_folder "../../", "/git/ovs", type: "rsync",
-                             rsync__args: ["--archive", "--delete", "-z"]
-    builder.vm.provision "builder", type: "ansible" do |ansible|
-      ansible.playbook = "../playbook-fedora-builder.yml"
-      ansible.sudo = true
-    end
-  end
-
-end
diff --git a/poc/playbook-centos-builder.yml b/poc/playbook-centos-builder.yml
deleted file mode 100644
index e902db75d..000000000
--- a/poc/playbook-centos-builder.yml
+++ /dev/null
@@ -1,108 +0,0 @@
----
-- hosts: all
-  become: true
-  name: builder
-  tasks:
-
-  - name: Create Ansible Local Facts Directory
-    file: path=/etc/ansible/facts.d state=directory
-
-  - name: Initiate Build Numbering
-    copy:
-        content: '{ "release":"1" }'
-        dest: "/etc/ansible/facts.d/builder.fact"
-        force: no
-
-  - name: Set source directory for building
-    set_fact:
-        SOURCE: "/root/rpmbuild/SOURCES"
-
-  - name: Reload Ansible Local Facts
-    setup: filter=ansible_local
-
-  - name: Install "yum-utils", "rpmdevtools", "createrepo", "httpd", "git"
-    yum: update_cache=yes name={{item}} state=present
-    with_items:
-      - yum-utils
-      - rpmdevtools
-      - createrepo
-      - httpd
-      - git
-
-  - name: Remove untracked files from Open vSwitch GIT repository
-    command: chdir=/git/ovs/ git clean -xdf
-
-  - name: Reset Open vSwitch GIT repository to last comitted state
-    command: chdir=/git/ovs/ git reset --hard
-
-  - name: Generate spec files for easy build dependency retrieval
-    shell: sed -e 's/@VERSION@/0.0.1/' {{item}}.in > /tmp/{{item}}
-    args:
-        chdir: /git/ovs/rhel
-    with_items:
-      - openvswitch.spec
-      - kmod-openvswitch-rhel6.spec
-
-  - name: Install build dependencies specified from spec files
-    shell: echo "y" | yum-builddep /tmp/{{item}}
-    with_items:
-      - openvswitch.spec
-      - kmod-openvswitch-rhel6.spec
-
-  - name: Create rpm dev tree
-    command: rpmdev-setuptree
-
-  - name: Run "./boot.sh"
-    command: chdir=/git/ovs/ ./boot.sh
-
-  - name: Run "./configure"
-    command: chdir=/git/ovs/ ./configure
-
-  - name: Run "make dist"
-    command: chdir=/git/ovs/ make dist
-
-  - name: Parse out Open vSwitch version from "configure.ac"
-    command: chdir=/git/ovs autoconf -t AC_INIT:'$2'
-    register: version
-
-  - name: Copy source tarball to rpm dev tree
-    command: cp /git/ovs/openvswitch-{{version.stdout}}.tar.gz {{SOURCE}}
-
-  - name: Unarchive openvswitch source tarball
-    unarchive:
-       src: "{{SOURCE}}/openvswitch-{{version.stdout}}.tar.gz"
-       dest: "{{SOURCE}}"
-       remote_src: yes
-
-  - name: Update release number in spec files
-    lineinfile:
-      path: "{{SOURCE}}/openvswitch-{{version.stdout}}/rhel/{{item}}"
-      regexp: '^Release:'
-      line: "Release: {{ ansible_local.builder.release }}"
-    with_items:
-      - openvswitch.spec
-      - kmod-openvswitch-rhel6.spec
-
-  - name: Build Open vSwitch user space rpms
-    command: rpmbuild -bb --without check rhel/openvswitch.spec
-    args:
-        chdir: "{{SOURCE}}/openvswitch-{{version.stdout}}"
-
-  - name: Build Open vSwitch kmod rpms (only for currently loaded kernel)
-    command: rpmbuild -bb  --without check rhel/kmod-openvswitch-rhel6.spec
-    args:
-        chdir: "{{SOURCE}}/openvswitch-{{version.stdout}}"
-
-  - name: Copy RPM packages to /var/www/html
-    command: cp -r /root/rpmbuild/RPMS/ /var/www/html
-
-  - name: Create RPM Package index file for repository
-    command: chdir=/var/www/html createrepo /var/www/html
-
-  - name: Make sure Apache is running
-    systemd: state=started name=httpd
-
-  - name: Bump up Build Number
-    copy:
-        content: '{ "release":"{{ansible_local.builder.release|int+1}}" }'
-        dest: "/etc/ansible/facts.d/builder.fact"
diff --git a/poc/playbook-fedora-builder.yml b/poc/playbook-fedora-builder.yml
deleted file mode 100644
index 70f0b6ff2..000000000
--- a/poc/playbook-fedora-builder.yml
+++ /dev/null
@@ -1,128 +0,0 @@
----
-- hosts: all
-  become: true
-  name: builder
-
-  gather_facts: false
-  pre_tasks:
-
-  - name: Install python2 for Ansible
-    raw: bash -c "test -e /usr/bin/python || (dnf -y install python2)"
-    register: output
-    changed_when: output.stdout != ""
-
-  - name: Gathering Facts
-    setup:
-
-  tasks:
-  - name: Create Ansible Local Facts Directory
-    file: path=/etc/ansible/facts.d state=directory
-
-  - name: Install "yum-utils", "rpmdevtools", "createrepo", "httpd", "git"
-    dnf: name={{item}} state=present
-    with_items:
-      - yum-utils
-      - rpmdevtools
-      - createrepo
-      - httpd
-      - git
-      - libselinux-python
-
-  - name: Initiate Build Numbering
-    copy:
-        content: '{ "release":"1" }'
-        dest: "/etc/ansible/facts.d/builder.fact"
-        force: no
-
-  - name: Set source directory for building
-    set_fact:
-        SOURCE: "/root/rpmbuild/SOURCES"
-
-  - name: Reload Ansible Local Facts
-    setup: filter=ansible_local
-
-  - name: Remove untracked files from Open vSwitch GIT repository
-    command: chdir=/git/ovs/ git clean -xdf
-
-  - name: Reset Open vSwitch GIT repository to last comitted state
-    command: chdir=/git/ovs/ git reset --hard
-
-  - name: Generate spec files for easy build dependency retrieval
-    shell: sed -e 's/@VERSION@/0.0.1/' {{item}}.in > /tmp/{{item}}
-    args:
-        chdir: /git/ovs/rhel
-    with_items:
-      - openvswitch-fedora.spec
-      - openvswitch-kmod-fedora.spec
-      - openvswitch-dkms.spec
-
-  - name: Install build dependencies specified from spec files
-    shell: echo "y" | yum-builddep /tmp/{{item}}
-    with_items:
-      - openvswitch-fedora.spec
-      - openvswitch-kmod-fedora.spec
-      - openvswitch-dkms.spec
-
-  - name: Create rpm dev tree
-    command: rpmdev-setuptree
-
-  - name: Run "./boot.sh"
-    command: chdir=/git/ovs/ ./boot.sh
-
-  - name: Run "./configure"
-    command: chdir=/git/ovs/ ./configure
-
-  - name: Run "make dist"
-    command: chdir=/git/ovs/ make dist
-
-  - name: Parse out Open vSwitch version from "configure.ac"
-    command: chdir=/git/ovs autoconf -t AC_INIT:'$2'
-    register: version
-
-  - name: Copy source tarball to rpm dev tree
-    command: cp /git/ovs/openvswitch-{{version.stdout}}.tar.gz {{SOURCE}}
-
-  - name: Unarchive openvswitch source tarball
-    unarchive:
-       src: "{{SOURCE}}/openvswitch-{{version.stdout}}.tar.gz"
-       dest: "{{SOURCE}}"
-       remote_src: yes
-
-  - name: Update release number in spec files
-    lineinfile:
-      path: "{{SOURCE}}/openvswitch-{{version.stdout}}/rhel/{{item}}"
-      regexp: '^Release:'
-      line: "Release: {{ ansible_local.builder.release }}"
-    with_items:
-      - openvswitch-fedora.spec
-      - openvswitch-kmod-fedora.spec
-      - openvswitch-dkms.spec
-
-  - name: Build Open vSwitch user space rpms
-    command: rpmbuild -bb --without check rhel/openvswitch-fedora.spec
-    args:
-        chdir: "{{SOURCE}}/openvswitch-{{version.stdout}}"
-
-  - name: Build Open vSwitch kmod rpm
-    command: rpmbuild -bb --without check rhel/openvswitch-fedora.spec
-    args:
-        chdir: "{{SOURCE}}/openvswitch-{{version.stdout}}"
-
-  - name: Build Open vSwitch dkms rpm
-    command: rpmbuild -bb --without check rhel/openvswitch-dkms.spec
-    args:
-        chdir: "{{SOURCE}}/openvswitch-{{version.stdout}}"
-
-  - name: Copy RPM packages to /var/www/html
-    command: cp -r /root/rpmbuild/RPMS/ /var/www/html
-
-  - name: Create RPM Package index file for repository
-    command: chdir=/var/www/html createrepo /var/www/html
-
-  - name: Make sure Apache is running
-    systemd: state=started name=httpd
-
-  - name: Bump up Build Number
-    copy:
-        content: '{ "release":"{{ansible_local.builder.release|int+1}}" }'
-        dest: "/etc/ansible/facts.d/builder.fact"
diff --git a/poc/playbook-ubuntu-builder.yml b/poc/playbook-ubuntu-builder.yml
deleted file mode 100644
index 5a13c6069..000000000
--- a/poc/playbook-ubuntu-builder.yml
+++ /dev/null
@@ -1,70 +0,0 @@
----
-- hosts: all
-  become: true
-  name: builder
-  gather_facts: no
-  pre_tasks:
-    - name: 'install python2'
-      raw: sudo apt-get -y install python-simplejson
-  tasks:
-
-  - name: Create Ansible Local Facts Directory
-    file: path=/etc/ansible/facts.d state=directory
-
-  - name: Initiate Build Numbering
-    copy:
-        content: '{ "release":"1" }'
-        dest: "/etc/ansible/facts.d/builder.fact"
-        force: no
-
-  - name: Reload Ansible Local Facts
-    setup: filter=ansible_local
-
-  - name: Install "devscripts", "equivs", "apache2", "autoconf"
-    apt: update_cache=yes name={{item}} state=present
-    with_items:
-      - devscripts
-      - equivs
-      - apache2
-      - autoconf
-
-  - name: Remove untracked files from Open vSwitch GIT repository
-    command: chdir=/git/ovs/ git clean -xdf
-
-  - name: Reset Open vSwitch GIT repository to last comitted state
-    command: chdir=/git/ovs/ git reset --hard
-
-  - name: Parse out Open vSwitch version from "configure.ac"
-    command: chdir=/git/ovs autoconf -t AC_INIT:'$2'
-    register: version
-
-  - name: Concatenate full version
-    set_fact:
-        full_version: "{{version.stdout}}-{{ansible_local.builder.release}}"
-
-  - name: Update Open vSwitch version to {{full_version}}
-    command: chdir=/git/ovs/ dch -b -v {{full_version}} Vagrant Build
-
-  - name: Build debian package with Open vSwitch build dependencies
-    command: chdir=/git/ovs/ mk-build-deps -B debian/control
-
-  - name: Install Open vSwitch {{full_version}} build dependencies
-    apt: deb=/git/ovs/openvswitch-build-deps-depends_{{full_version}}_all.deb
-
-  - name: Build Open vSwitch {{full_version}} debian packages
-    shell: DEB_BUILD_OPTIONS='nocheck' fakeroot debian/rules binary
-    args:
-       chdir: /git/ovs/
-
-  - name: Move debian packages to /var/www/html
-    shell: mv /git/*.deb /var/www/html/
-
-  - name: Create Debian Package index file for repository
-    shell: dpkg-scanpackages . | gzip -9c > Packages.gz
-    args:
-       chdir: /var/www/html
-
-  - name: Bump up Build Number
-    copy:
-        content: '{ "release":"{{ansible_local.builder.release|int+1}}" }'
-        dest: "/etc/ansible/facts.d/builder.fact"